// src/backend/cpu_policy_exception.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2. If not, see http://www.gnu.org/licenses/.


// Warning! This exception will be thrown across different libraries.
// It could be necessary to do dynamic type-checking when
// catching it (with typeinfo).

#ifndef CPU_POLICY_EXCEPTION
#define CPU_POLICY_EXCEPTION 1

#include <sgpemv2/sgpemv2-visibility.hh>

#include <stdexcept>

namespace sgpem
{
  class CPUPolicyException;

  class SG_DLLEXPORT CPUPolicyException : public std::runtime_error
  {
  public:
    explicit CPUPolicyException(const std::string& msg = "");
  };
} //~ namespace sgpem

#endif
