// src/backend/resource_policy_manager.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2. If not, see http://www.gnu.org/licenses/.


#ifndef RESOURCE_POLICY_MANAGER_HH
#define RESOURCE_POLICY_MANAGER_HH 1

namespace sgpem
{
  class ResourcePolicy;
}

#include <sgpemv2/sgpemv2-visibility.hh>

#include <vector>


namespace sgpem
{
  class ResourcePolicyManager;

  /**
    ResourcePolicyManager is the Abstract Factory for \ref ResourcePolicy objects.
  */
  class SG_DLLEXPORT ResourcePolicyManager
  {
  public:
    typedef ResourcePolicy Policy;
    typedef std::vector<Policy*> Policies;
    /** \brief ResourcePolicyManager constructor
     *
     * Registers itself to the ResourcePoliciesGatekeeper singleton.
    */
    ResourcePolicyManager();

    virtual ~ResourcePolicyManager();

    virtual const Policies& get_avail_policies() const = 0;
  };

} //~ namespace sgpem

#endif // ~ RESOURCE_POLICY_MANAGER_HH

